%Exercise Questions

%Part 1
%Vectors and matrices

%Q: Can you create a 4 x 4 matrix B?

%A:
clear all % clear all variables 
close all % close all figures
B =[1 3 2 4; 5 6 7 9; 8 3 1 7]
%%

%Part 2
%Plotting functions in 2D

%Q: Can you plot the function x*tan(x^2) between [0 1]?

%A:
clear all % clear all variables 
close all % close all figures
fplot(@(x) x*tan(x^2), [0 1])
%%

%Part3
%Newton's method

%Q: Can you use Newton's method to approximate the root of the function 
%   f(x) = x^3 - 2x - 5 starting with x_1 = 2?

%A:
clear all % clear all variables 
close all % close all figures

syms x;
f(x) = x^3 - 2*x - 5;
df = diff(f, x);

F(x) = x - f(x)/df(x);

k = 2;

for i = 1:1000
    
    y = vpa(F(k));
    k = y;
    
    if abs(f(k))<10^(-5)
        break
    end
end

k     % print value of root, 2.09455148
f(k)  % print value of function (error), 1.7398e-09
%%

%Part 4
%Plotting functions in 3D

%Q: Can you plot the hyperbolic paraboloid z = y^2 - x^2 where -20<=x<=20 
%   and -20<=y<=20?

%A:
clear all % clear all variables 
close all % close all figures

[X, Y] = meshgrid(-20:0.5:20);

N = size(X);

Z = zeros(N(1), N(2));

F = @(x, y) (y^2) - (x^2);

for i = 1:N(1)
    for j = 1:N(2)
        
        Z(i,j) = F(X(i,j), Y(i,j));
        
    end
end

surf(X, Y, Z)
xlabel('x values');
ylabel('y values');
zlabel('z values');
title('Example hyperbolic paraboloid');
%%

%Part 5
%Plotting a list of points

%Q: Can you plot your own list of points?

%A:

clear all % clear all variables
close all % close all figures

x = [1:5];
y = [10 8 21 90 80];

plot(x, y, 'r.') %'.' plots the points and 'r' plots the points as red
%%

%Part 6
%Contour plot

%Q: Can you create the contour plot of the hyperbolic paraboloid 
%   z = y^2 - x^2, where -20<=x<=20 and -20<=y<=20, at the contour levels
%   z = 1, 10, 100?

%A:
clear all % clear all variables
close all % close all figures

[X, Y] = meshgrid(-20:0.5:20);

N = size(X);

Z = zeros(N(1), N(2));

F = @(x, y) y^2 - x^2;

for i = 1:N(1)
    for j = 1:N(2)
        
        Z(i,j) = F(X(i,j), Y(i,j));
        
    end
end

v = [1; 10; 100];
[C, h] = contour(X, Y, Z, v); %Vector v contains the values of z selected
                              %for the contour plot
clabel(C,h)
xlabel('x values');
ylabel('y values');
title('Contour plot of example hyperbolic paraboloid');
%%

%Part 7
%Basic matrix operations

%Q: Can you solve a matrix equation of the form A x = b, where
%   A = [2 2 2; 2 3 6; 1 4 -2] and b = [5; -3; 26]?

%A:
clear all % clear all variables
close all % close all figures

A = [2 2 2; 2 3 6; 1 4 -2];
b = [5; -3; 26];

x = mldivide(A, b)

%or

clear all % clear all variables
close all % close all figures
A = sym([2 2 2; 2 3 6; 1 4 -2]);
b = sym([5; -3; 26]);
x = mldivide(A, b)
%%

%Part 8
%Eigenvalues and eigenvectors

%Q: Find the eigenvalues and eigenvectors of the 2x2 matrix
%   A = [2 4; 1 5]

%A:
clear all % clear all variables
close all % close all figures

A = sym([2 4; 1 5]);
[V, D] = eig(A);

D %Eigenvalues are 1 and 6

V %Right eigenvectors are [-4; 1] and [1; 1]
%%

%Part 9
%Solving nonlinear equations

%Q: Can you solve the following system of nonlinear equations?
%   x^2 - y^2 + 2x = 0
%   2x + y^2 - 6 = 0

clear all % clear all variables
close all % close all figures

syms x y;

[solx, soly] = solve([x^2 - y^2 + 2*x == 0, 2*x + y^2 - 6 == 0], x, y);

solx % (31^(1/2)*i)/4 - 1/4
     % -(31^(1/2)*i)/4 - 1/4
     
soly % (31^(1/2)*i)/8 - 1/8
     % -(31^(1/2)*i)/8 - 1/8





